Index: /java/FramclipsePlugin/src/main/resources/framscontext.xsl
===================================================================
--- /java/FramclipsePlugin/src/main/resources/framscontext.xsl	(revision 263)
+++ /java/FramclipsePlugin/src/main/resources/framscontext.xsl	(revision 264)
@@ -9,11 +9,19 @@
 
 <xsl:template match="framscontext">
+<style>
+.file {color:red;}
+.context-code {color: #00ee00;} 
+.context-file {color: #007700;} 
+.objects {color: #0000ff;} 
+</style>
+
   <h1>Framscript Context Configuration</h1>
-<i>Note:
+
+<b>Each <span class="file">file type</span> may contain <span class="objects">objects</span> from many <span class="context-file">contexts</span>, as specified below.<br/>Each <span class="context-file">context</span> may contain many <span class="objects">objects</span>, as specified below.<br/>Note:
   <xsl:choose><xsl:when test="count(document('framscript.xml')/framscript)=0">
-	This formatting sheet would also use <a href="framscript.xml">framscript.xml</a> to show object names if that file was available</xsl:when>
-<xsl:otherwise>This formatting sheet also includes object names extracted from <a href="framscript.xml">framscript.xml</a></xsl:otherwise>
+	This formatting sheet (xsl) would use <a href="framscript.xml">framscript.xml</a> to show object names if that file was available!</xsl:when>
+<xsl:otherwise>This formatting sheet (xsl) includes object names extracted from <a href="framscript.xml">framscript.xml</a>.</xsl:otherwise>
 	</xsl:choose>
-</i>
+</b><br/><br/><br/>
 
   <table border="1">
@@ -25,9 +33,9 @@
 <xsl:template match="file">
   <tr valign="top">
-   <td><b><xsl:value-of select="@label"/></b><br/><xsl:value-of select="@pattern"/></td>
+   <td class="file"><b><xsl:value-of select="@label"/></b><br/><xsl:value-of select="@pattern"/></td>
    <td>
 	<xsl:if test="count(code)!=0">
 	<p title="Defined by &lt;objects&gt;">
-	Objects defined in the following contexts can be stored directly in the file: (using the standard framsticks format)<ul><xsl:apply-templates select="objects"/></ul>
+	Objects defined in the following contexts can be stored directly in the file (using the standard Framsticks <a href="http://www.framsticks.com/common/formatspec.html">format</a>):<ul><xsl:apply-templates select="objects"/></ul>
 	</p>
 	<xsl:apply-templates select="code"/>
@@ -86,6 +94,21 @@
 </xsl:template>
 
+
+
+
+<xsl:template name="extobjects">
+  <xsl:param name="objs"/>
+  <xsl:if test="count($objs)!=0">
+  (
+  <xsl:for-each select="$objs">
+	<font class="objects"><xsl:value-of select="@name"/></font>,
+  </xsl:for-each>
+  )
+  </xsl:if>
+</xsl:template>
+
+
 <xsl:template match="objects">
-  <li><b><xsl:value-of select="@context"/></b>
+  <li><b><span class="context-file"><xsl:value-of select="@context"/></span></b>
 	<xsl:variable name="context" select="@context"/>
       	<xsl:call-template name="extobjects"><xsl:with-param name="objs" select="document('framscript.xml')/framscript/type[@context=$context]"/></xsl:call-template>
@@ -94,5 +117,5 @@
 
 <xsl:template match="script">
-  <li><b><xsl:value-of select="@context"/></b>
+  <li><b><span class="context-code"><xsl:value-of select="@context"/></span></b>
 	<xsl:variable name="context" select="@context"/>
       	<xsl:call-template name="extobjects"><xsl:with-param name="objs" select="document('framscript.xml')/framscript/type[@context=$context]"/></xsl:call-template>
@@ -100,21 +123,12 @@
 </xsl:template>
 
-<xsl:template name="extobjects">
-  <xsl:param name="objs"/>
-  <xsl:if test="count($objs)!=0">
-  (
-  <xsl:for-each select="$objs">
-	<xsl:value-of select="@name"/>,
-  </xsl:for-each>
-  )
-  </xsl:if>
-</xsl:template>
-
 <xsl:template match="context">
-  <li><b><xsl:value-of select="@name"/></b>
+  <li><b><span class="context-code"><xsl:value-of select="@name"/></span></b>
 	<xsl:variable name="context" select="@name"/>
       	<xsl:call-template name="extobjects"><xsl:with-param name="objs" select="document('framscript.xml')/framscript/type[@context=$context]"/></xsl:call-template>
   </li>
 </xsl:template>
+
+
 
 <xsl:template match="code">
@@ -126,5 +140,5 @@
 <xsl:template match="properties">
   <li>
-  <b><xsl:value-of select="@to"/></b> is defined by "<xsl:value-of select="@from"/>" objects
+  <span class="objects"><b><xsl:value-of select="@to"/></b></span> is defined by <span class="objects"><xsl:value-of select="@from"/></span> objects
   </li>
 </xsl:template>