Index: cpp/frams/_demos/f0_variants_test.cpp
===================================================================
--- cpp/frams/_demos/f0_variants_test.cpp	(revision 283)
+++ cpp/frams/_demos/f0_variants_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <stdlib.h>
Index: cpp/frams/_demos/full_props.cpp
===================================================================
--- cpp/frams/_demos/full_props.cpp	(revision 283)
+++ cpp/frams/_demos/full_props.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <stdlib.h>
Index: cpp/frams/_demos/gdk_test.cpp
===================================================================
--- cpp/frams/_demos/gdk_test.cpp	(revision 283)
+++ cpp/frams/_demos/gdk_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <stdlib.h>
Index: cpp/frams/_demos/geno_test.cpp
===================================================================
--- cpp/frams/_demos/geno_test.cpp	(revision 283)
+++ cpp/frams/_demos/geno_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <frams/virtfile/stdiofile.h>
Index: cpp/frams/_demos/genoconv_test.cpp
===================================================================
--- cpp/frams/_demos/genoconv_test.cpp	(revision 283)
+++ cpp/frams/_demos/genoconv_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <ctype.h>
Index: cpp/frams/_demos/genooper_test.cpp
===================================================================
--- cpp/frams/_demos/genooper_test.cpp	(revision 283)
+++ cpp/frams/_demos/genooper_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <frams/errmgr/stdouterr.h>
Index: cpp/frams/_demos/genooper_test_fTest.cpp
===================================================================
--- cpp/frams/_demos/genooper_test_fTest.cpp	(revision 283)
+++ cpp/frams/_demos/genooper_test_fTest.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <frams/genetics/fT/oper_fTest.h>
Index: cpp/frams/_demos/genotypeloader.cpp
===================================================================
--- cpp/frams/_demos/genotypeloader.cpp	(revision 283)
+++ cpp/frams/_demos/genotypeloader.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include "genotypeloader.h"
Index: cpp/frams/_demos/genotypeloader.h
===================================================================
--- cpp/frams/_demos/genotypeloader.h	(revision 283)
+++ cpp/frams/_demos/genotypeloader.h	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #ifndef _GENOTYPELOADER_H_
Index: cpp/frams/_demos/geometry/apices_test.cpp
===================================================================
--- cpp/frams/_demos/geometry/apices_test.cpp	(revision 283)
+++ cpp/frams/_demos/geometry/apices_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include "geometrytestutils.h"
Index: cpp/frams/_demos/geometry/geometrytestutils.cpp
===================================================================
--- cpp/frams/_demos/geometry/geometrytestutils.cpp	(revision 283)
+++ cpp/frams/_demos/geometry/geometrytestutils.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include "geometrytestutils.h"
Index: cpp/frams/_demos/geometry/geometrytestutils.h
===================================================================
--- cpp/frams/_demos/geometry/geometrytestutils.h	(revision 283)
+++ cpp/frams/_demos/geometry/geometrytestutils.h	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #ifndef _GEOMETRYTESTUTILS_H_
Index: cpp/frams/_demos/geometry/info_test.cpp
===================================================================
--- cpp/frams/_demos/geometry/info_test.cpp	(revision 283)
+++ cpp/frams/_demos/geometry/info_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include "geometrytestutils.h"
Index: cpp/frams/_demos/geometry/surface_test.cpp
===================================================================
--- cpp/frams/_demos/geometry/surface_test.cpp	(revision 283)
+++ cpp/frams/_demos/geometry/surface_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include "geometrytestutils.h"
Index: cpp/frams/_demos/geometry/volume_test.cpp
===================================================================
--- cpp/frams/_demos/geometry/volume_test.cpp	(revision 283)
+++ cpp/frams/_demos/geometry/volume_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include "geometrytestutils.h"
Index: cpp/frams/_demos/loader_test.cpp
===================================================================
--- cpp/frams/_demos/loader_test.cpp	(revision 283)
+++ cpp/frams/_demos/loader_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include "genotypeloader.h"
Index: cpp/frams/_demos/multiline_f0_test.cpp
===================================================================
--- cpp/frams/_demos/multiline_f0_test.cpp	(revision 283)
+++ cpp/frams/_demos/multiline_f0_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <stdlib.h>
Index: cpp/frams/_demos/neuro_layout_test.cpp
===================================================================
--- cpp/frams/_demos/neuro_layout_test.cpp	(revision 283)
+++ cpp/frams/_demos/neuro_layout_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <frams/virtfile/stdiofile.h>
Index: cpp/frams/_demos/neuro_test.cpp
===================================================================
--- cpp/frams/_demos/neuro_test.cpp	(revision 283)
+++ cpp/frams/_demos/neuro_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <frams/genetics/geno.h>
Index: cpp/frams/_demos/part_shapes.cpp
===================================================================
--- cpp/frams/_demos/part_shapes.cpp	(revision 283)
+++ cpp/frams/_demos/part_shapes.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <stdio.h>
Index: cpp/frams/_demos/printconvmap.cpp
===================================================================
--- cpp/frams/_demos/printconvmap.cpp	(revision 283)
+++ cpp/frams/_demos/printconvmap.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include "printconvmap.h"
Index: cpp/frams/_demos/printconvmap.h
===================================================================
--- cpp/frams/_demos/printconvmap.h	(revision 283)
+++ cpp/frams/_demos/printconvmap.h	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #ifndef _PRINTCONVMAP_H_
Index: cpp/frams/_demos/serial_test.cpp
===================================================================
--- cpp/frams/_demos/serial_test.cpp	(revision 283)
+++ cpp/frams/_demos/serial_test.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <frams/vm/classes/collectionobj.h>
Index: cpp/frams/_demos/shapeconvert.cpp
===================================================================
--- cpp/frams/_demos/shapeconvert.cpp	(revision 283)
+++ cpp/frams/_demos/shapeconvert.cpp	(revision 286)
@@ -1,5 +1,5 @@
-// This file is a part of the Framsticks GDK.
-// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.framsticks.com/ for further information.
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
 
 #include <stdlib.h>